dnl  mpn_addmul_1 -- Multiply a limb vector with a limb and add
dnl  the result to a second limb vector.

dnl  Copyright 2001, 2002, 2004, 2005 Free Software Foundation, Inc.
dnl
dnl  This file is part of the GNU MP Library.
dnl
dnl  The GNU MP Library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU Lesser General Public License as
dnl  published by the Free Software Foundation; either version 3 of the
dnl  License, or (at your option) any later version.
dnl
dnl  The GNU MP Library is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl  Lesser General Public License for more details.
dnl
dnl  You should have received a copy of the GNU Lesser General Public License
dnl  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

dnl
dnl *********************************************************************
dnl
dnl  Modified by ct35z, 2008/03/28
dnl

include(`../config.m4')


C mp_limb_t mpn_addmul_1 (mp_ptr dst, mp_srcptr src, mp_size_t size,
C                         mp_limb_t multiplier);
C mp_limb_t mpn_addmul_1c (mp_ptr dst, mp_srcptr src, mp_size_t size,
C                          mp_limb_t multiplier, mp_limb_t carry);


defframe(PARAM_CARRY,     20)
defframe(PARAM_MULTIPLIER,16)
defframe(PARAM_SIZE,      12)
defframe(PARAM_SRC,       8)
defframe(PARAM_DST,       4)

	TEXT
	ALIGN(16)
PROLOGUE(mpn_addmul_1c)
deflit(`FRAME',0)
	movd	PARAM_CARRY, %xmm0
	jmp	L(start_1c)
EPILOGUE()

PROLOGUE(mpn_addmul_1)
deflit(`FRAME',0)
	pxor	%xmm0, %xmm0
L(start_1c):
	pushl	%edi
	pushl	%esi
deflit(`FRAME',8)

	movl	PARAM_SIZE, %edx
	movl	PARAM_SRC, %esi
	movd	PARAM_MULTIPLIER, %xmm7
	movl	PARAM_DST, %edi

	movd	(%esi), %xmm1
	movdqa	%xmm1, %xmm3
	movd	(%edi),%xmm2

	movl	%edx,%ecx
	decl	%edx
	andl	$15,%edx
	leal	1(%edx),%eax

	movl	L(inner0_jmptbl)(,%edx,4),%edx
	jmp		*%edx

	ALIGN(4)
L(inner0_jmptbl):
	.long	L(inner0_s1)
	.long	L(inner0_s2)
	.long	L(inner0_s3)
	.long	L(inner0_s4)
	.long	L(inner0_s5)
	.long	L(inner0_s6)
	.long	L(inner0_s7)
	.long	L(inner0_s8)
	.long	L(inner0_s9)
	.long	L(inner0_s10)
	.long	L(inner0_s11)
	.long	L(inner0_s12)
	.long	L(inner0_s13)
	.long	L(inner0_s14)
	.long	L(inner0_s15)
	.long	L(inner0_s16)

L(inner0):
	addl	$16,%eax
							C Upper 64bits of xmm registers are not used.
	movd	-64+4*0(%esi,%eax,4), %xmm1
	movd	-64+4*0(%edi,%eax,4),%xmm2
L(inner0_s16):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*1(%esi,%eax,4), %xmm3
		movd	-64+4*1(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*0(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s15):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*2(%esi,%eax,4), %xmm1
	movd	-64+4*2(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*1(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s14):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*3(%esi,%eax,4), %xmm3
		movd	-64+4*3(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*2(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s13):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*4(%esi,%eax,4), %xmm1
	movd	-64+4*4(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*3(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s12):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*5(%esi,%eax,4), %xmm3
		movd	-64+4*5(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*4(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s11):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*6(%esi,%eax,4), %xmm1
	movd	-64+4*6(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*5(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s10):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*7(%esi,%eax,4), %xmm3
		movd	-64+4*7(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*6(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s9):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*8(%esi,%eax,4), %xmm1
	movd	-64+4*8(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*7(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s8):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*9(%esi,%eax,4), %xmm3
		movd	-64+4*9(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*8(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s7):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*10(%esi,%eax,4), %xmm1
	movd	-64+4*10(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*9(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s6):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*11(%esi,%eax,4), %xmm3
		movd	-64+4*11(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*10(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s5):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*12(%esi,%eax,4), %xmm1
	movd	-64+4*12(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*11(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s4):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*13(%esi,%eax,4), %xmm3
		movd	-64+4*13(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*12(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s3):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*14(%esi,%eax,4), %xmm1
	movd	-64+4*14(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*13(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s2):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*15(%esi,%eax,4), %xmm3
		movd	-64+4*15(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*14(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s1):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*15(%edi,%eax,4)
		psrlq	$32, %xmm0

	cmpl	%ecx,%eax
	jnz		L(inner0)
L(inner0_end):

	movd	%xmm0, %eax

	popl	%esi
	popl	%edi
	ret

EPILOGUE()
