dnl  x86 mpn_add_n/mpn_sub_n -- mpn addition and subtraction.

dnl  Copyright 1992, 1994, 1995, 1996, 1999, 2000, 2001, 2002 Free Software
dnl  Foundation, Inc.
dnl
dnl  This file is part of the GNU MP Library.
dnl
dnl  The GNU MP Library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU Lesser General Public License as
dnl  published by the Free Software Foundation; either version 3 of the
dnl  License, or (at your option) any later version.
dnl
dnl  The GNU MP Library is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl  Lesser General Public License for more details.
dnl
dnl  You should have received a copy of the GNU Lesser General Public License
dnl  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

dnl
dnl *********************************************************************
dnl
dnl  Modified by ct35z, 2008/03/25
dnl


include(`../config.m4')



ifdef(`OPERATION_add_n',`
	define(M4_inst,        adcl)
	define(M4_function_n,  mpn_add_n)
	define(M4_function_nc, mpn_add_nc)

',`ifdef(`OPERATION_sub_n',`
	define(M4_inst,        sbbl)
	define(M4_function_n,  mpn_sub_n)
	define(M4_function_nc, mpn_sub_nc)

',`m4_error(`Need OPERATION_add_n or OPERATION_sub_n
')')')

MULFUNC_PROLOGUE(mpn_add_n mpn_add_nc mpn_sub_n mpn_sub_nc)


C mp_limb_t M4_function_n (mp_ptr dst, mp_srcptr src1, mp_srcptr src2,
C                          mp_size_t size);
C mp_limb_t M4_function_nc (mp_ptr dst, mp_srcptr src1, mp_srcptr src2,
C	                    mp_size_t size, mp_limb_t carry);

defframe(PARAM_CARRY,20)
defframe(PARAM_SIZE, 16)
defframe(PARAM_SRC2, 12)
defframe(PARAM_SRC1, 8)
defframe(PARAM_DST,  4)

	TEXT
	ALIGN(8)

PROLOGUE(M4_function_nc)
deflit(`FRAME',0)

	pushl	%edi		FRAME_pushl()
	pushl	%esi		FRAME_pushl()

	movl	PARAM_SIZE,%ecx
	movl	PARAM_SRC1,%esi
	movl	PARAM_SRC2,%edx
	movl	PARAM_DST,%edi

	movl	%ecx,%eax
	shll	$2,%eax			C adjustment for pointers...
	addl	%eax,%edi		C ... since they are offset ...
	addl	%eax,%esi		C ... by a constant when we ...
	addl	%eax,%edx		C ... enter the loop

	andl	$-16,%ecx
	negl	%ecx

	andl	$15*4,%eax
	negl	%eax
	leal	L(oop_bottom)(%eax,%eax,2),%eax		C 12 bytes per
	
	pushl	%ebp
	movl	PARAM_CARRY,%ebp
	shrl	$1,%ebp			C shift bit 0 into carry
	popl	%ebp
	jmp		*%eax


EPILOGUE()


	ALIGN(16)
PROLOGUE(M4_function_n)
deflit(`FRAME',0)

	pushl	%edi		FRAME_pushl()
	pushl	%esi		FRAME_pushl()

	movl	PARAM_SIZE,%ecx
	movl	PARAM_SRC1,%esi
	movl	PARAM_SRC2,%edx
	movl	PARAM_DST,%edi

	movl	%ecx,%eax
	shll	$2,%eax			C adjustment for pointers...
	addl	%eax,%edi		C ... since they are offset ...
	addl	%eax,%esi		C ... by a constant when we ...
	addl	%eax,%edx		C ... enter the loop

	andl	$-16,%ecx
	negl	%ecx

	andl	$15*4,%eax
	negl	%eax
	leal	L(oop_bottom)(%eax,%eax,2),%eax		C 12 bytes per
	
	orl		%eax,%eax		C Clear carryflag
	jmp		*%eax

	ALIGN(16)
L(oop):
	leal	16(%ecx),%ecx

	movl	-4*16(%esi,%ecx,4),%eax
	M4_inst	-4*16(%edx,%ecx,4),%eax
	movl	%eax,-4*16(%edi,%ecx,4)

	movl	-4*15(%esi,%ecx,4),%eax
	M4_inst	-4*15(%edx,%ecx,4),%eax
	movl	%eax,-4*15(%edi,%ecx,4)

	movl	-4*14(%esi,%ecx,4),%eax
	M4_inst	-4*14(%edx,%ecx,4),%eax
	movl	%eax,-4*14(%edi,%ecx,4)

	movl	-4*13(%esi,%ecx,4),%eax
	M4_inst	-4*13(%edx,%ecx,4),%eax
	movl	%eax,-4*13(%edi,%ecx,4)

	movl	-4*12(%esi,%ecx,4),%eax
	M4_inst	-4*12(%edx,%ecx,4),%eax
	movl	%eax,-4*12(%edi,%ecx,4)

	movl	-4*11(%esi,%ecx,4),%eax
	M4_inst	-4*11(%edx,%ecx,4),%eax
	movl	%eax,-4*11(%edi,%ecx,4)

	movl	-4*10(%esi,%ecx,4),%eax
	M4_inst	-4*10(%edx,%ecx,4),%eax
	movl	%eax,-4*10(%edi,%ecx,4)

	movl	-4*9(%esi,%ecx,4),%eax
	M4_inst	-4*9(%edx,%ecx,4),%eax
	movl	%eax,-4*9(%edi,%ecx,4)

	movl	-4*8(%esi,%ecx,4),%eax
	M4_inst	-4*8(%edx,%ecx,4),%eax
	movl	%eax,-4*8(%edi,%ecx,4)

	movl	-4*7(%esi,%ecx,4),%eax
	M4_inst	-4*7(%edx,%ecx,4),%eax
	movl	%eax,-4*7(%edi,%ecx,4)

	movl	-4*6(%esi,%ecx,4),%eax
	M4_inst	-4*6(%edx,%ecx,4),%eax
	movl	%eax,-4*6(%edi,%ecx,4)

	movl	-4*5(%esi,%ecx,4),%eax
	M4_inst	-4*5(%edx,%ecx,4),%eax
	movl	%eax,-4*5(%edi,%ecx,4)

	movl	-4*4(%esi,%ecx,4),%eax
	M4_inst	-4*4(%edx,%ecx,4),%eax
	movl	%eax,-4*4(%edi,%ecx,4)

	movl	-4*3(%esi,%ecx,4),%eax
	M4_inst	-4*3(%edx,%ecx,4),%eax
	movl	%eax,-4*3(%edi,%ecx,4)

	movl	-4*2(%esi,%ecx,4),%eax
	M4_inst	-4*2(%edx,%ecx,4),%eax
	movl	%eax,-4*2(%edi,%ecx,4)

	movl	-4*1(%esi,%ecx,4),%eax
	M4_inst	-4*1(%edx,%ecx,4),%eax
	movl	%eax,-4*1(%edi,%ecx,4)
L(oop_bottom):
	jecxz	L(oop_end)		C Partial flag stall is avoided because lea,jecxz don't break any flags.
	jmp		L(oop)

L(oop_end):
	setc	%al
	movzbl	%al, %eax

	popl	%esi
	popl	%edi
	ret


EPILOGUE()
