dnl  mpn_mul_basecase -- mpn by mpn multiplication.

dnl  Copyright 2001, 2002 Free Software Foundation, Inc.
dnl
dnl  This file is part of the GNU MP Library.
dnl
dnl  The GNU MP Library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU Lesser General Public License as
dnl  published by the Free Software Foundation; either version 2.1 of the
dnl  License, or (at your option) any later version.
dnl
dnl  The GNU MP Library is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl  Lesser General Public License for more details.
dnl
dnl  You should have received a copy of the GNU Lesser General Public
dnl  License along with the GNU MP Library; see the file COPYING.LIB.  If
dnl  not, write to the Free Software Foundation, Inc., 51 Franklin Street,
dnl  Fifth Floor, Boston, MA 02110-1301, USA.

dnl
dnl *********************************************************************
dnl
dnl  Modified by ct35z, 2008/03/28
dnl


include(`../config.m4')


C void mpn_mul_basecase (mp_ptr wp,
C                        mp_srcptr xp, mp_size_t xsize,
C                        mp_srcptr yp, mp_size_t ysize);
C

defframe(PARAM_YSIZE, 20)
defframe(PARAM_YP,    16)
defframe(PARAM_XSIZE, 12)
defframe(PARAM_XP,    8)
defframe(PARAM_WP,    4)

	TEXT
	ALIGN(8)
PROLOGUE(mpn_mul_basecase)
deflit(`FRAME',0)
	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
deflit(`FRAME',16)

	pxor	%xmm0, %xmm0		C initial carry

	movl	PARAM_YP, %edx

	movl	PARAM_XP, %esi

	movd	(%edx), %xmm7		C yp[0]

	movl	PARAM_XSIZE, %ebx
	movl	%ebx,%ecx

	movl	PARAM_YSIZE, %ebp

	movl	PARAM_WP, %edi

	andl	$15,%ebx
	movl	%ebx,%eax
	movl	L(mul0_jmptbl)(,%ebx,4),%ebx
	jmp		*%ebx

	ALIGN(4)
L(mul0_jmptbl):
	.long	L(mul0_s0)
	.long	L(mul0_s1)
	.long	L(mul0_s2)
	.long	L(mul0_s3)
	.long	L(mul0_s4)
	.long	L(mul0_s5)
	.long	L(mul0_s6)
	.long	L(mul0_s7)
	.long	L(mul0_s8)
	.long	L(mul0_s9)
	.long	L(mul0_s10)
	.long	L(mul0_s11)
	.long	L(mul0_s12)
	.long	L(mul0_s13)
	.long	L(mul0_s14)
	.long	L(mul0_s15)

L(mul0_loop):
	addl	$16,%eax
							C Upper 64bits of xmm registers are not used.
	movd	-64+4*0(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*0(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s15):
	movd	-64+4*1(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*1(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s14):
	movd	-64+4*2(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*2(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s13):
	movd	-64+4*3(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*3(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s12):
	movd	-64+4*4(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*4(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s11):
	movd	-64+4*5(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*5(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s10):
	movd	-64+4*6(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*6(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s9):
	movd	-64+4*7(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*7(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s8):
	movd	-64+4*8(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*8(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s7):
	movd	-64+4*9(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*9(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s6):
	movd	-64+4*10(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*10(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s5):
	movd	-64+4*11(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*11(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s4):
	movd	-64+4*12(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*12(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s3):
	movd	-64+4*13(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*13(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s2):
	movd	-64+4*14(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*14(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s1):
	movd	-64+4*15(%esi,%eax,4), %xmm1
	pmuludq	%xmm7, %xmm1
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*15(%edi,%eax,4)
	psrlq	$32, %xmm0
L(mul0_s0):
L(mul0_start):
	cmpl	%ecx,%eax
	jnz		L(mul0_loop)
L(mul0_end):

	movd	%xmm0, (%edi,%ecx,4)

	decl	%ebp
	jz	L(done)


	leal	-1(%ecx),%ebx

	andl	$15,%ebx
	movl	%ebx,%eax
	incl	%ebx
	movl	L(inner0_jmptbl)(,%eax,4),%eax
	pushl	%eax

L(outer):
	addl	$4, %edi

	movd	(%esi), %xmm1
	movdqa	%xmm1, %xmm3
	movd	(%edi),%xmm2

	movl	%ebx,%eax

	movd	4(%edx), %xmm7		C next yp limb
	addl	$4, %edx

	pxor	%xmm0, %xmm0		C initial carry

	jmp	*(%esp)

	ALIGN(4)
L(inner0_jmptbl):
	.long	L(inner0_s1)
	.long	L(inner0_s2)
	.long	L(inner0_s3)
	.long	L(inner0_s4)
	.long	L(inner0_s5)
	.long	L(inner0_s6)
	.long	L(inner0_s7)
	.long	L(inner0_s8)
	.long	L(inner0_s9)
	.long	L(inner0_s10)
	.long	L(inner0_s11)
	.long	L(inner0_s12)
	.long	L(inner0_s13)
	.long	L(inner0_s14)
	.long	L(inner0_s15)
	.long	L(inner0_s16)

L(inner0):
	addl	$16,%eax
							C Upper 64bits of xmm registers are not used.
	movd	-64+4*0(%esi,%eax,4), %xmm1
	movd	-64+4*0(%edi,%eax,4),%xmm2
L(inner0_s16):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*1(%esi,%eax,4), %xmm3
		movd	-64+4*1(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*0(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s15):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*2(%esi,%eax,4), %xmm1
	movd	-64+4*2(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*1(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s14):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*3(%esi,%eax,4), %xmm3
		movd	-64+4*3(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*2(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s13):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*4(%esi,%eax,4), %xmm1
	movd	-64+4*4(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*3(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s12):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*5(%esi,%eax,4), %xmm3
		movd	-64+4*5(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*4(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s11):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*6(%esi,%eax,4), %xmm1
	movd	-64+4*6(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*5(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s10):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*7(%esi,%eax,4), %xmm3
		movd	-64+4*7(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*6(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s9):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*8(%esi,%eax,4), %xmm1
	movd	-64+4*8(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*7(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s8):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*9(%esi,%eax,4), %xmm3
		movd	-64+4*9(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*8(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s7):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*10(%esi,%eax,4), %xmm1
	movd	-64+4*10(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*9(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s6):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*11(%esi,%eax,4), %xmm3
		movd	-64+4*11(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*10(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s5):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*12(%esi,%eax,4), %xmm1
	movd	-64+4*12(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*11(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s4):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*13(%esi,%eax,4), %xmm3
		movd	-64+4*13(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*12(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s3):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
	movd	-64+4*14(%esi,%eax,4), %xmm1
	movd	-64+4*14(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*13(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s2):
	pmuludq	%xmm7, %xmm1
	paddq	%xmm2, %xmm1
		movd	-64+4*15(%esi,%eax,4), %xmm3
		movd	-64+4*15(%edi,%eax,4),%xmm2
	paddq	%xmm1, %xmm0
	movd	%xmm0, -64+4*14(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s1):
		pmuludq	%xmm7, %xmm3
		paddq	%xmm2, %xmm3
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*15(%edi,%eax,4)
		psrlq	$32, %xmm0

	cmpl	%ecx,%eax
	jnz		L(inner0)
L(inner0_end):

	movd	%xmm0, (%edi,%ecx,4)

	decl	%ebp
	jnz	L(outer)

	addl	$4, %esp

L(done):
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret

EPILOGUE()
