dnl  mpn_submul_1 -- Multiply a limb vector with a limb and
dnl  subtract the result from a second limb vector.

dnl  Copyright 2001, 2002 Free Software Foundation, Inc.
dnl
dnl  This file is part of the GNU MP Library.
dnl
dnl  The GNU MP Library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU Lesser General Public License as
dnl  published by the Free Software Foundation; either version 3 of the
dnl  License, or (at your option) any later version.
dnl
dnl  The GNU MP Library is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl  Lesser General Public License for more details.
dnl
dnl  You should have received a copy of the GNU Lesser General Public License
dnl  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

dnl
dnl *********************************************************************
dnl
dnl  Modified by ct35z, 2008/03/28
dnl

include(`../config.m4')


C mp_limb_t mpn_submul_1 (mp_ptr dst, mp_srcptr src, mp_size_t size,
C                         mp_limb_t mult);
C mp_limb_t mpn_submul_1c (mp_ptr dst, mp_srcptr src, mp_size_t size,
C                          mp_limb_t mult, mp_limb_t carry);


defframe(PARAM_CARRY,     20)
defframe(PARAM_MULTIPLIER,16)
defframe(PARAM_SIZE,      12)
defframe(PARAM_SRC,       8)
defframe(PARAM_DST,       4)

	TEXT
	ALIGN(16)
PROLOGUE(mpn_submul_1c)
deflit(`FRAME',0)
	movd	PARAM_CARRY, %xmm5
	jmp	L(start_1c)
EPILOGUE()

PROLOGUE(mpn_submul_1)
deflit(`FRAME',0)
	pxor	%xmm5, %xmm5
L(start_1c):
	pushl	%edi
	pushl	%esi
deflit(`FRAME',8)

	movl	PARAM_SIZE, %edx
	movl	PARAM_SRC, %esi
	movd	PARAM_MULTIPLIER, %xmm7
	movl	PARAM_DST, %edi

	movd	(%esi), %xmm1
	movd	(%edi),%xmm2
	movdqa	%xmm2, %xmm3

	movq	Value0xFFFFFFFE00000001, %xmm6
	movq	Value0x00000000FFFFFFFF, %xmm0
	psubq	%xmm5, %xmm0		C 0xFFFFFFFF - borrow

	movl	%edx,%ecx
	andl	$15,%edx
	movl	%edx,%eax

	movl	L(inner0_jmptbl)(,%edx,4),%edx
	jmp		*%edx

	ALIGN(8)
Value0xFFFFFFFE00000001:
	.quad	0xFFFFFFFE00000001
Value0x00000000FFFFFFFF:
	.quad	0x00000000FFFFFFFF
	ALIGN(4)
L(inner0_jmptbl):
	.long	L(inner0_s0)
	.long	L(inner0_s1)
	.long	L(inner0_s2)
	.long	L(inner0_s3)
	.long	L(inner0_s4)
	.long	L(inner0_s5)
	.long	L(inner0_s6)
	.long	L(inner0_s7)
	.long	L(inner0_s8)
	.long	L(inner0_s9)
	.long	L(inner0_s10)
	.long	L(inner0_s11)
	.long	L(inner0_s12)
	.long	L(inner0_s13)
	.long	L(inner0_s14)
	.long	L(inner0_s15)

L(inner0):
	addl	$16,%eax
							C Upper 64bits of xmm registers are not used.
	movd	-64+4*0(%esi,%eax,4), %xmm1
	movd	-64+4*0(%edi,%eax,4),%xmm2
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*1(%esi,%eax,4), %xmm1
		movd	-64+4*1(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*0(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s15):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*2(%esi,%eax,4), %xmm1
	movd	-64+4*2(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*1(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s14):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*3(%esi,%eax,4), %xmm1
		movd	-64+4*3(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*2(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s13):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*4(%esi,%eax,4), %xmm1
	movd	-64+4*4(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*3(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s12):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*5(%esi,%eax,4), %xmm1
		movd	-64+4*5(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*4(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s11):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*6(%esi,%eax,4), %xmm1
	movd	-64+4*6(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*5(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s10):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*7(%esi,%eax,4), %xmm1
		movd	-64+4*7(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*6(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s9):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*8(%esi,%eax,4), %xmm1
	movd	-64+4*8(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*7(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s8):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*9(%esi,%eax,4), %xmm1
		movd	-64+4*9(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*8(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s7):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*10(%esi,%eax,4), %xmm1
	movd	-64+4*10(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*9(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s6):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*11(%esi,%eax,4), %xmm1
		movd	-64+4*11(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*10(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s5):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*12(%esi,%eax,4), %xmm1
	movd	-64+4*12(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*11(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s4):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*13(%esi,%eax,4), %xmm1
		movd	-64+4*13(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*12(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s3):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
	movd	-64+4*14(%esi,%eax,4), %xmm1
	movd	-64+4*14(%edi,%eax,4),%xmm2
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*13(%edi,%eax,4)
		psrlq	$32, %xmm0
L(inner0_s2):
	paddq	%xmm6, %xmm2
	pmuludq	%xmm7, %xmm1
	psubq	%xmm1, %xmm2
		movd	-64+4*15(%esi,%eax,4), %xmm1
		movd	-64+4*15(%edi,%eax,4),%xmm3
	paddq	%xmm2, %xmm0
	movd	%xmm0, -64+4*14(%edi,%eax,4)
	psrlq	$32, %xmm0
L(inner0_s1):
		paddq	%xmm6, %xmm3
		pmuludq	%xmm7, %xmm1
		psubq	%xmm1, %xmm3
		paddq	%xmm3, %xmm0
		movd	%xmm0, -64+4*15(%edi,%eax,4)
		psrlq	$32, %xmm0
		
L(inner0_s0):


L(inner0_start):
	cmpl	%ecx,%eax
	jnz		L(inner0)
L(inner0_end):

	movd	%xmm0, %eax
	notl	%eax

	popl	%esi
	popl	%edi
	ret

EPILOGUE()
