dnl  AMD64 mpn_sub_n -- Subtract two limb vectors of the same length > 0 and
dnl  store difference in a third limb vector.

dnl  Copyright 2004 Free Software Foundation, Inc.

dnl  This file is part of the GNU MP Library.

dnl  The GNU MP Library is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU Lesser General Public License as published
dnl  by the Free Software Foundation; either version 3 of the License, or (at
dnl  your option) any later version.

dnl  The GNU MP Library is distributed in the hope that it will be useful, but
dnl  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
dnl  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
dnl  License for more details.

dnl  You should have received a copy of the GNU Lesser General Public License
dnl  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

dnl
dnl *********************************************************************
dnl
dnl  Modified by ct35z, 2008/03/16
dnl


include(`../config.m4')


C INPUT PARAMETERS
C rp	rdi
C up	rsi
C vp	rdx
C n	rcx

ASM_START()
PROLOGUE(mpn_sub_n)

	movq	%rcx, %rax
	shlq	$3, %rax
	addq	%rax, %rsi
	addq	%rax, %rdi
	addq	%rax, %rdx

	movq	%rcx, %rax
	andq	$15, %rax
	movq	%rax, %r8
	shlq	$4, %rax
	subq	%r8, %rax	C 15 bytes per

	andq	$-16, %rcx
	negq	%rcx

	leaq	L(loop_bottom)(%rip), %r8
	subq	%rax, %r8

	xorl	%eax, %eax		C clear cy
	jmp	*%r8

	ALIGN(16)			C minimal alignment for claimed speed
L(loop):
	leaq	16(%rcx), %rcx

	movq	-8*16(%rsi,%rcx,8), %rax
	sbbq	-8*16(%rdx,%rcx,8), %rax
	movq	%rax, -8*16(%rdi,%rcx,8)

	movq	-8*15(%rsi,%rcx,8), %rax
	sbbq	-8*15(%rdx,%rcx,8), %rax
	movq	%rax, -8*15(%rdi,%rcx,8)

	movq	-8*14(%rsi,%rcx,8), %rax
	sbbq	-8*14(%rdx,%rcx,8), %rax
	movq	%rax, -8*14(%rdi,%rcx,8)

	movq	-8*13(%rsi,%rcx,8), %rax
	sbbq	-8*13(%rdx,%rcx,8), %rax
	movq	%rax, -8*13(%rdi,%rcx,8)

	movq	-8*12(%rsi,%rcx,8), %rax
	sbbq	-8*12(%rdx,%rcx,8), %rax
	movq	%rax, -8*12(%rdi,%rcx,8)

	movq	-8*11(%rsi,%rcx,8), %rax
	sbbq	-8*11(%rdx,%rcx,8), %rax
	movq	%rax, -8*11(%rdi,%rcx,8)

	movq	-8*10(%rsi,%rcx,8), %rax
	sbbq	-8*10(%rdx,%rcx,8), %rax
	movq	%rax, -8*10(%rdi,%rcx,8)

	movq	-8*9(%rsi,%rcx,8), %rax
	sbbq	-8*9(%rdx,%rcx,8), %rax
	movq	%rax, -8*9(%rdi,%rcx,8)

	movq	-8*8(%rsi,%rcx,8), %rax
	sbbq	-8*8(%rdx,%rcx,8), %rax
	movq	%rax, -8*8(%rdi,%rcx,8)

	movq	-8*7(%rsi,%rcx,8), %rax
	sbbq	-8*7(%rdx,%rcx,8), %rax
	movq	%rax, -8*7(%rdi,%rcx,8)

	movq	-8*6(%rsi,%rcx,8), %rax
	sbbq	-8*6(%rdx,%rcx,8), %rax
	movq	%rax, -8*6(%rdi,%rcx,8)

	movq	-8*5(%rsi,%rcx,8), %rax
	sbbq	-8*5(%rdx,%rcx,8), %rax
	movq	%rax, -8*5(%rdi,%rcx,8)

	movq	-8*4(%rsi,%rcx,8), %rax
	sbbq	-8*4(%rdx,%rcx,8), %rax
	movq	%rax, -8*4(%rdi,%rcx,8)

	movq	-8*3(%rsi,%rcx,8), %rax
	sbbq	-8*3(%rdx,%rcx,8), %rax
	movq	%rax, -8*3(%rdi,%rcx,8)

	movq	-8*2(%rsi,%rcx,8), %rax
	sbbq	-8*2(%rdx,%rcx,8), %rax
	movq	%rax, -8*2(%rdi,%rcx,8)

	movq	-8*1(%rsi,%rcx,8), %rax
	sbbq	-8*1(%rdx,%rcx,8), %rax
	movq	%rax, -8*1(%rdi,%rcx,8)
L(loop_bottom):
	jrcxz	L(loop_end)		C Partial flag stall is avoided because lea,jrcxz don't break any flags.
	jmp	L(loop)
L(loop_end):

	movq	%rcx, %rax		C zero %rax
	adcq	%rax, %rax
	ret
EPILOGUE()
